'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = botimizeBotkit;

var _fs = require('fs');

var fs = _interopRequireWildcard(_fs);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var BotkitMiddlewareBase = function () {
  function BotkitMiddlewareBase(botimize) {
    _classCallCheck(this, BotkitMiddlewareBase);

    this.botimize = botimize;
    // In ES5, need to bind this when internal function calling.
    this.receive = this.receive.bind(this);
    this.send = this.send.bind(this);
  }

  _createClass(BotkitMiddlewareBase, [{
    key: 'transferIncoming',
    value: function transferIncoming(bot, message) {
      console.log('transfer incoming message in botimize base.');
      return message;
    }
  }, {
    key: 'transferOutgoing',
    value: function transferOutgoing(bot, message) {
      console.log('transfer outgoing message in botimize base.');
      return message;
    }
  }, {
    key: 'receive',
    value: function receive(bot, message, next) {
      this.botimize.logIncoming(this.transferIncoming(bot, message), 'botkit');
      next();
    }
  }, {
    key: 'send',
    value: function send(bot, message, next) {
      this.botimize.logOutgoing(this.transferOutgoing(bot, message), 'botkit');
      next();
    }
  }]);

  return BotkitMiddlewareBase;
}();

var Facebook = function (_BotkitMiddlewareBase) {
  _inherits(Facebook, _BotkitMiddlewareBase);

  function Facebook(botimize) {
    _classCallCheck(this, Facebook);

    return _possibleConstructorReturn(this, (Facebook.__proto__ || Object.getPrototypeOf(Facebook)).call(this, botimize));
  }

  _createClass(Facebook, [{
    key: 'transferIncoming',
    value: function transferIncoming(bot, message) {
      var fbMessage = {
        "sender": { "id": message.user },
        "timestamp": message.timestamp,
        "message": {}
      };

      if (message.text) {
        fbMessage.message.text = message.text;
      }

      if (message.seq) {
        fbMessage.message.seq = message.seq;
      }

      if (message.mid) {
        fbMessage.message.mid = message.mid;
      }

      if (message.sticker_id) {
        fbMessage.message.sticker_id = message.sticker_id;
      }

      if (message.attachments) {
        fbMessage.message.attachments = message.attachments;
      }

      if (message.quick_reply) {
        fbMessage.message.quick_reply = message.quick_reply;
      }

      return {
        "object": "page",
        "entry": [{
          "time": message.timestamp,
          "messaging": [fbMessage]
        }]
      };
    }
  }, {
    key: 'transferOutgoing',
    value: function transferOutgoing(bot, message) {
      var fbMessage = {
        "recipient": {},
        "message": {}
      };

      if (typeof message.channel == 'string' && message.channel.match(/\+\d+\(\d\d\d\)\d\d\d\-\d\d\d\d/)) {
        fbMessage.recipient.phone_number = message.channel;
      } else {
        fbMessage.recipient.id = message.channel;
      }

      if (message.text) {
        fbMessage.message.text = message.text;
      }

      if (message.attachment) {
        fbMessage.message.attachment = message.attachment;
      }

      if (message.sticker_id) {
        fbMessage.message.sticker_id = message.sticker_id;
      }

      if (message.quick_replies) {
        fbMessage.message.quick_replies = message.quick_replies;
      }

      fbMessage.access_token = bot.botkit.config.access_token;

      return fbMessage;
    }
  }]);

  return Facebook;
}(BotkitMiddlewareBase);

var Slack = function (_BotkitMiddlewareBase2) {
  _inherits(Slack, _BotkitMiddlewareBase2);

  function Slack(botimize) {
    _classCallCheck(this, Slack);

    return _possibleConstructorReturn(this, (Slack.__proto__ || Object.getPrototypeOf(Slack)).call(this, botimize));
  }

  _createClass(Slack, [{
    key: 'addTeamInfo',
    value: function addTeamInfo(bot, message) {
      var id = JSON.parse(JSON.stringify(bot.identify));
      var teamInfo = JSON.parse(JSON.stringify(bot.team_info));
      delete id.prefs;
      delete teamInfo.prefs;
      teamInfo.bot = id;

      return {
        "team": teamInfo,
        "bot": id,
        "token": bot.config.token,
        "message": message
      };
    }
  }, {
    key: 'transferIncoming',
    value: function transferIncoming(bot, message) {
      return addTeamInfo(bot, message);
    }
  }, {
    key: 'transferOutgoing',
    value: function transferOutgoing(bot, message) {
      return addTeamInfo(bot, message);
    }
  }, {
    key: 'receive',
    value: function receive(bot, message, next) {
      if (message.type !== 'reconnect_url') {
        this.track('incoming', this.transferIncoming(bot, message));
      }
      next();
    }
  }]);

  return Slack;
}(BotkitMiddlewareBase);

function botimizeBotkit(botimize) {
  if (botimize.platform === 'facebook') {
    return new Facebook(botimize);
  } else if (botimize.platform === 'slack') {
    return new Slack(botimize);
  } else {
    throw new Error('Invalid platform');
  }
}
module.exports = exports['default'];